/*
 * Copyright (c) 2003-2006 Erez Zadok
 * Copyright (c) 2003-2006 Stony Brook University
 * Copyright (c) 2003-2006 The Research Foundation of State University of New York
 * Copyright (c) 2004-2006 Nikolai Joukov
 * Copyright (c) 2003-2005 Akshat Aranya
 * Copyright (c) 2006-2006 Gopala Surya
 */

#ifndef __NAMEHASH_H
#define __NAMEHASH_H

struct names {
    char *name;
    int parent_inum;
    struct names *next;
};

struct namehash_entry {
	int inum;
	struct names *namelist;
        struct namehash_entry *next;
};

struct namehash {
	int size;
	struct namehash_entry *buckets[0];
};

struct namehash *create_namehash(int buckets);
void destroy_namehash(struct namehash *hash);
struct namehash_entry *lookup(struct namehash *hasht, int inum);
struct namehash_entry *add_entry(struct namehash *hasht, int inum, int parent_inum, char *name);

#endif
